HDU 6103 Kirinriki (思维 双指针)

Kirinriki

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 2169    Accepted Submission(s): 879

Problem Description

We define the distance of two strings A and B with same length n is
disA,B=∑i=0n−1|Ai−Bn−1−i|
The difference between the two characters is defined as the difference in ASCII.
You should find the maximum length of two non-overlapping substrings in given string S, and the distance between them are less then or equal to m.

Input

The first line of the input gives the number of test cases T; T test cases follow.
Each case begins with one line with one integers m : the limit distance of substring.
Then a string S follow.

Limits
T≤100
0≤m≤5000
Each character in the string is lowercase letter, 2≤|S|≤5000
∑|S|≤20000

Output

For each test case output one interge denotes the answer : the maximum length of the substring.

Sample Input

1
5
abcdefedcb

Sample Output

5

Hint

[0, 4] abcde
[5, 9] fedcb
The distance between them is abs(‘a‘ - ‘b‘) + abs(‘b‘ - ‘c‘) + abs(‘c‘ - ‘d‘) + abs(‘d‘ - ‘e‘) + abs(‘e‘ - ‘f‘) = 5

Source

2017 Multi-University Training Contest - Team 6

【题意】给你一个字符串,找到两个不相交的相同长度的子串,使得|Ai−Bn−1−i|求和小于等于m,求子串最大长度。

【分析】可以枚举前缀,然后双指针,这种做法需要翻转一下再来一次,不懂得可以看看这个样例abcdefghi 答案是 def  ghi,然后还可以枚举对称轴,这个不需要翻转。

#include <bits/stdc++.h>
#define inf 0x3f3f3f3f
#define met(a,b) memset(a,b,sizeof a)
#define pb push_back
#define mp make_pair
#define rep(i,l,r) for(int i=(l);i<=(r);++i)
#define inf 0x3f3f3f3f
using namespace std;
typedef long long ll;
const int N = 5e3+50;;
const int M = 255;
const int mod = 998244353;
const int mo=123;
const double pi= acos(-1.0);
typedef pair<int,int>pii;
typedef pair<ll,int>P;
int n,m,ans;
char str[N];
void solve(){
    for(int len=2;len<=n;len++){
        for(int l=1,r=1,res=0;r<=len/2;r++){
            res+=abs(str[r]-str[len-r+1]);
            while(res>m){
                res-=abs(str[l]-str[len-l+1]);
                l++;
            }
            ans=max(ans,r-l+1);
        }
    }
}
int main(){
    int T;
    scanf("%d",&T);
    while(T--){
        scanf("%d",&m);
        scanf("%s",str+1);
        n=strlen(str+1);
        ans=0;
        solve();
        reverse(str+1,str+1+n);
        solve();
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-11-05 12:38:08

HDU 6103 Kirinriki (思维 双指针)的相关文章

HDU 6103 Kirinriki(尺取法)

http://acm.hdu.edu.cn/showproblem.php?pid=6103 题意: 给出一个字符串,在其中找两串互不重叠的子串,计算它们之间的dis值,要求dis值小于等于m,求能选的子串的最大长度. 思路: 由于这两个子串是互不重叠的,那么这两个子串之间的间隔可以是奇数也可以是偶数,针对这两种情况我们枚举中心点,然后尺取法处理,具体看代码就懂了. 1 #include<iostream> 2 #include<algorithm> 3 #include<c

HDU 6103 Kirinriki 枚举长度 尺取法

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=6103 题目描述: 定义两个相同长度的字符串的值为首尾开始字符串的ASCII相减, 求一个字符串中任取两个相同长度的不重叠的值不超过m的最大长度 解题思路: 求连续区间不超过某一个上限或者不低于某个下限的应该用尺取法 ,复杂度为O(n),  本题n是5000所以O(n^2)可行, 枚举前缀和后缀(通过枚举前缀, 再将字符串翻转枚举前缀进行), 再进行尺取 代码:  代码中有注释 #include <

hdu 6103 Kirinriki

题意:给出字符串s,以及m,计算距离字符串距离:dis(A,B)=∑|Ai?B|n?1?i|,在距离小于等于m的条件下找到最长的子串,并输出长度. 题解:官方题解就很好啊,从中心点向两边扩展,,如果合法,外层指针继续扩展,如果不合法,内层指针向外扩展.枚举一下中心向外延伸. 第一次是找到实质的中心点,依次扩展(存在中心点和邻接中心点的位置比较不到的问题),第二次是比较中心点和邻近中心点的位置. #include <stdio.h> #include <algorithm> #inc

hdu 4550 贪心 思维题 不错

http://acm.hdu.edu.cn/showproblem.php?pid=4550 想了挺久,然后各种分类 终于AC,如果是现场,对自己没信心的话,估计还是要WA,,,,,,然后搜题解,发现人家都认为是简单题,看来我还是太弱了,牡丹江没有做出来K看来还是自己贪心和思维有问题 d是一个Deque 最朴素的算法是,如果当前的数<=d.front(),那么插入队列的前面,否则插入队列后面,但是有零所以需要单独处理,还是自己多举例找规律 我的策略: 1.记录0的个数zero,最小非零的数的个数

HDU 5776 sum (思维题)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5776 题目让你求是否有区间的和是m的倍数. 预处理前缀和,一旦有两个数模m的值相同,说明中间一部分连续子列可以组成m的倍数. 1 //#pragma comment(linker, "/STACK:102400000, 102400000") 2 #include <algorithm> 3 #include <iostream> 4 #include <cs

hdu 4803 贪心/思维题

http://acm.hdu.edu.cn/showproblem.php?pid=4803 话说C++还卡精度么?  G++  AC  C++ WA 我自己的贪心策略错了 -- 就是尽量下键,然后上键,最后下键补全,可是例子都过不了..... 题解參考http://www.cnblogs.com/xuesu/p/3967704.html http://www.cnblogs.com/Canon-CSU/p/3451784.html http://blog.csdn.net/keshuai199

HDU 6098 Inversion 思维

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=6098 题目描述: 给出一个序列, 让你求序列中所有不能整除i的最大值并输出  i  属于 2 ~ n 解题思路: 这道题我犯蠢了......我想的是找规律, 所有质数先求出来再单独抠倍数, 其实只要排序就好了..... 代码: #include <iostream> #include <cstdio> #include <string> #include <vect

hdu 4474 BFS+思维题

http://acm.hdu.edu.cn/showproblem.php?pid=4474 如果A%n ==B %n  (A<B) 那么A接下来A经若干次填位数使得A'%n==0,这个过程也可以使B'%n==0  但是显然A更小,所以开一个1e4的数组判重 犯得二逼错误: 1.需要记录每一位,不是mod%10就是每一位 2.第一位枚举1~9,但是仍然需要%n 3.必然需要高精度,开始ll  WA到死 #include <cstdio> #include <cstring>

HDU - 5765 Bonds 思维 + sosdp(子集和dp)

HDU - 5765 一个bond肯定把n个点分成两个连通块, 并且每个集合对应一个bond, 因为当前这个集合属于第一个连通块, 那么它的补集就输入另一个连通块, ok[ mask ] 表示 mask这些点集能否成为一个连通块. 我们称一个分配方案mask是好的当且仅当ok[ mask ] == true && ok[ ~mask ] = true; 那么我们考虑一条边(u, v)属于多少个bond, 也就是总的合法的分配方案  减去 u, v在同一个点集里的方案数. 我们考虑sosdp